//--basic post test - start this and then restart the esp
(
OSCFunc({|msg|
	msg.postln;  //incoming broadcast ping
	n= NetAddr("%.%.%.%".format(*msg[2..]), 11080);
	n.sendMsg(\pong);  //reply with pong to start streaming
	OSCFunc({|msg|
		msg.postln;
	}, \f06dof, recvPort: 11081);
}, \f06dof_ping, recvPort: 11081);
)
//cmd+. to stop






//--advanced test
(
d= IdentityDictionary[];  //ID, [NetAddr, Synth]
s.latency= 0.05;
s.waitForBoot{
	SynthDef(\xyz, {|amp= 0, freq= 400, oct= 1, det= 0, width= 0.5, pan= 0|
		var snd= VarSaw.ar(freq*oct+det, 0, width);
		Out.ar(0, Pan2.ar(LeakDC.ar(snd)*amp, pan));
	}, #[0.1, 0.1, 0.1, 0.1, 0.1, 0.1]).add;
	OSCFunc({|msg|
		var n= NetAddr("%.%.%.%".format(*msg[2..]), 11080);
		var f= Scale.minorPentatonic.degreeToFreq(msg[1], 60.midicps, 0);
		msg.postln;
		d.put(msg[1], [n, Synth(\xyz, [\freq, f])]);
		n.sendMsg(\pong);
		OSCdef(\accelgyro, {|msg|
			var id= msg[1];
			var ax= msg[2]/32768;
			var ay= msg[3]/32768;
			var az= msg[4]/32768;
			var gx= msg[5]/32768;
			var gy= msg[6]/32768;
			var gz= msg[7]/32768;
			msg.postln;
			//[id, ax, ay, az, gx, gy, gz].postln;  //debug
			d[id][1].set(
				\amp, gx+gy+gz,
				\oct, 1.5-(az.sign/2),
				\det, gy*10,
				\width, az/2+1,
				\pan, ax,
			);
		}, \f06dof, recvPort: 11081);
	}, \f06dof_ping, recvPort: 11081);
	CmdPeriod.doOnce({d.do{|x| x[0].sendMsg(\restart)}});
};
)

(
d.do{|x|
	x[0].sendMsg(\update_rate, 40);  //default 16
};
)
(
d.do{|x|
	x[0].sendMsg(\num_mean, 20);  //default 5
};
)
(
d.do{|x|
	x[0].sendMsg(\quantise, 10);  //default 2
};
)
(
d.do{|x|
	x[0].sendMsg(\thresh_min, 500, \thresh_max, 7500);  //default 5, 75
};
)

//reset
(
d.do{|x|
	x[0].sendMsg(\restart);
	x[1].free;
};
)
